std::__debug::deque< _Tp, _Allocator > Class Template Reference
Inheritance diagram for std::__debug::deque< _Tp, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, deque > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< _Base_iterator, deque > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Tp | value_type

## Public Member Functions

| deque (const deque &)=default
| deque (deque &&)=default
| deque (const deque &__d, const _Allocator &__a)
| deque (deque &&__d, const _Allocator &__a)
| deque (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
| deque (const _Allocator &__a)
| deque (size_type __n, const _Allocator &__a=_Allocator())
| deque (size_type __n, const _Tp &__value, const _Allocator &__a=_Allocator())
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
| deque (_InputIterator __first, _InputIterator __last, const _Allocator &__a=_Allocator())
| deque (const _Base &__x)
void | _M_attach (_Safe_iterator_base *__it, bool __constant)
void | _M_attach_single (_Safe_iterator_base *__it, bool __constant) throw ()
_Base & | _M_base () noexcept
const _Base & | _M_base () const noexcept
void | _M_detach (_Safe_iterator_base *__it)
void | _M_detach_single (_Safe_iterator_base *__it) throw ()
void | _M_invalidate_all () const
void | _M_invalidate_if (_Predicate __pred)
void | _M_swap (_Safe_container &__x) noexcept
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
void | assign (_InputIterator __first, _InputIterator __last)
void | assign (size_type __n, const _Tp &__t)
void | assign (initializer_list< value_type > __l)
reference | back () noexcept
const_reference | back () const noexcept
iterator | begin () noexcept
const_iterator | begin () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (const_iterator __position, _Args &&... __args)
template<typename... _Args>
void | emplace_back (_Args &&... __args)
template<typename... _Args>
void | emplace_front (_Args &&... __args)
iterator | end () noexcept
const_iterator | end () const noexcept
iterator | erase (const_iterator __position)
iterator | erase (const_iterator __first, const_iterator __last)
reference | front () noexcept
const_reference | front () const noexcept
iterator | insert (const_iterator __position, const _Tp &__x)
iterator | insert (const_iterator __position, _Tp &&__x)
iterator | insert (const_iterator __position, initializer_list< value_type > __l)
iterator | insert (const_iterator __position, size_type __n, const _Tp &__x)
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
deque & | operator= (const deque &)=default
deque & | operator= (deque &&)=default
deque & | operator= (initializer_list< value_type > __l)
reference | operator[] (size_type __n) noexcept
const_reference | operator[] (size_type __n) const noexcept
void | pop_back () noexcept
void | pop_front () noexcept
void | push_back (const _Tp &__x)
void | push_back (_Tp &&__x)
void | push_front (const _Tp &__x)
void | push_front (_Tp &&__x)
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend () noexcept
const_reverse_iterator | rend () const noexcept
void | resize (size_type __sz)
void | resize (size_type __sz, const _Tp &__c)
void | shrink_to_fit () noexcept
void | swap (deque &__x) noexcept(noexcept(declval< _Base >().swap(__x)))

## Public Attributes

_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_iterators
unsigned int | _M_version

## Protected Member Functions

void | _M_detach_all ()
void | _M_detach_singular ()
__gnu_cxx::__mutex & | _M_get_mutex () throw ()
void | _M_revalidate_singular ()
_Safe_container & | _M_safe () noexcept
void | _M_swap (_Safe_sequence_base &__x) noexcept

## Detailed Description

### template<typename _Tp, typename _Allocator = std::allocator<_Tp>>
class std::__debug::deque< _Tp, _Allocator >

Class std::deque with safety/checking/debug instrumentation.

Definition at line 43 of file debug/deque.

## Member Function Documentation

## _M_attach()

void __gnu_debug::_Safe_sequence_base::_M_attach | ( | _Safe_iterator_base * | __it,
|  | bool | __constant
| ) |  |

inherited

Attach an iterator to this sequence.

## _M_attach_single()

void __gnu_debug::_Safe_sequence_base::_M_attach_single | ( | _Safe_iterator_base * | __it,
|  | bool | __constant
| ) |  |
throw | ( |
| ) |  |

inherited

Likewise but not thread safe.

## _M_detach()

void __gnu_debug::_Safe_sequence_base::_M_detach | ( | _Safe_iterator_base * | __it | ) |

inherited

Detach an iterator from this sequence

## _M_detach_all()

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) |

protected inherited

Detach all iterators, leaving them singular.

## _M_detach_single()

void __gnu_debug::_Safe_sequence_base::_M_detach_single | ( | _Safe_iterator_base * | __it | ) |
throw | ( |
| ) |  |

inherited

Likewise but not thread safe.

## _M_detach_singular()

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) |

protected inherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

## _M_get_mutex()

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) |
throw | ( |
| ) |  |

protected inherited

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

## _M_invalidate_all()

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const

inline inherited

Invalidates all iterators.

Definition at line 241 of file safe_base.h.

References __gnu_debug::_Safe_iterator_base::_M_attach(), __gnu_debug::_Safe_iterator_base::_M_attach_single(), __gnu_debug::_Safe_iterator_base::_M_detach(), and __gnu_debug::_Safe_iterator_base::_M_detach_single().

## _M_invalidate_if()

void __gnu_debug::_Safe_sequence< deque< _Tp, _Allocator > >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 38 of file safe_sequence.tcc.

## _M_revalidate_singular()

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) |

protected inherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

## _M_swap()

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) |

protected noexcept inherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## _M_transfer_from_if()

void __gnu_debug::_Safe_sequence< deque< _Tp, _Allocator > >::_M_transfer_from_if | ( | _Safe_sequence< deque< _Tp, _Allocator > > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 69 of file safe_sequence.tcc.

## Member Data Documentation

## _M_const_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators

inherited

The list of constant iterators that reference this container.

Definition at line 186 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

## _M_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators

inherited

The list of mutable iterators that reference this container.

Definition at line 183 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

## _M_version

unsigned int __gnu_debug::_Safe_sequence_base::_M_version

mutable inherited

The container version number. This number may never be 0.

Definition at line 189 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/deque